﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

[Serializable]
[Microsoft.SqlServer.Server.SqlUserDefinedType(Format.UserDefined, MaxByteSize = 12)]
public struct PointIBinarySerialize : INullable, IBinarySerialize
{
    public override string ToString()
    {
        return x.ToString() + ", " + y.ToString();
    }

    public bool IsNull
    {
        get
        {
            return _null;
        }
    }

    public static PointIBinarySerialize Null
    {
        get
        {
            PointIBinarySerialize h = new PointIBinarySerialize();
            h._null = true;
            return h;
        }
    }

    public static PointIBinarySerialize Parse(SqlString s)
    {
        if (s.IsNull)
            return Null;
        PointIBinarySerialize u = new PointIBinarySerialize();
        string[] parts = s.Value.Split(',');
        u.x = int.Parse(parts[0].Trim());
        u.y = int.Parse(parts[1].Trim());
        return u;
    }


    private int x, y;
    private bool _null;

    #region IBinarySerialize Members

    public void Read(System.IO.BinaryReader r)
    {
        _null = r.ReadBoolean();
        x = r.ReadInt32();
        y = r.ReadInt32();
    }

    public void Write(System.IO.BinaryWriter w)
    {
        w.Write(_null);
        w.Write(x);
        w.Write(y);
    }

    #endregion
}


