﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

[Serializable]
[Microsoft.SqlServer.Server.SqlUserDefinedType(Format.Native)]
public struct PointNative : INullable
{
    public override string ToString()
    {
        return x.ToString() + ", " + y.ToString();
    }

    public bool IsNull
    {
        get
        {
            return _null;
        }
    }

    public static PointNative Null
    {
        get
        {
            PointNative h = new PointNative();
            h._null = true;
            return h;
        }
    }

    public static PointNative Parse(SqlString s)
    {
        if (s.IsNull)
            return Null;
        PointNative u = new PointNative();
        string[] parts = s.Value.Split(',');
        u.x = int.Parse(parts[0].Trim());
        u.y = int.Parse(parts[1].Trim());
        return u;
    }

    private int x, y;
    // Private member
    private bool _null;
}


